--[[----------------------------------------------------------------------------

ADOBE CONFIDENTIAL
------------------
Copyright 2018 Adobe Systems Incorporated
All Rights Reserved.

NOTICE: All information contained herein is, and remain the property of
Adobe Systems Incorporated and its suppliers, if any. The intellectual and
technical concepts contained herein are proprietary to Adobe Systems
Incorporated and its suppliers and may be covered by U.S. and Foreign
Patents, patents in process, and are protected by trade secret or copyright
law.  Dissemination of this information or reproduction of this material is
strictly forbidden unless prior written permission is obtained from
Adobe Systems Incorporated.

-------------------------------------------------------------------------------]]

local Rx = require 'Rx'

local LriDiagnosticLogProvider = require( 'LriDiagnosticLogProvider' )

--------------------------------------------------------------------------------

local LriDiagnosticLogProviderProcessor = {}

--------------------------------------------------------------------------------

function LriDiagnosticLogProviderProcessor.makeDiagnosticLogProviderModel()

    return {
        _nativeLogProviderMap = {},

        value = Rx.BehaviorSubject(),

        events = {
			
			registerLogProvider = function( self, name )
		
	            local provider = LriDiagnosticLogProvider( name )
	            self._nativeLogProviderMap[ name ] = provider
				
            end,
            
            deregisterLogProvider = function( self, name )

                local provider = self._nativeLogProviderMap[ name ]
                provider:close()
                self._nativeLogProviderMap[ name ] = nil
                
            end,
			
		}
    }
	
end

--------------------------------------------------------------------------------

return LriDiagnosticLogProviderProcessor
